// Parag K. Mital

#ifndef _TEST_APP
#define _TEST_APP

#define NUMBER_OF_GLASS_BALLS 17

//#define MAX_NUM_FACES_TO_KEEP 1000

#define OG_CAMERA_WIDTH 640
#define OG_CAMERA_HEIGHT 480
#define CAMERA_SCALE 2
#define CAMERA_WIDTH (OG_CAMERA_WIDTH / CAMERA_SCALE)
#define CAMERA_HEIGHT (OG_CAMERA_HEIGHT / CAMERA_SCALE)
#define SCREEN_WIDTH 1024
#define SCREEN_HEIGHT 768
#define FACE_WIDTH 128
#define FACE_HEIGHT 128

#define SECOND_CAMERA 0
#define NUM_CAMERAS 1

#ifndef OF_ADDON_USING_OFXOPENCV
#define OF_ADDON_USING_OFXOPENCV
#endif

#include "cv.h"
#include "cvaux.h"
#include "ofMain.h"
#include "ofAddons.h"
#include "ofxCvHaarFinder.h"
#include "ofQtVideoSaver.h"
#include "ofVideoPlayer.h"
#include "glassBall.h"
#include "ofShader.h"

class testApp : public ofSimpleApp{

	public:

	testApp();
	~testApp();
		void setup();
		void update();
		void draw();

		void keyPressed			(int key);
		void mouseMoved			(int x, int y );
		void mouseDragged		(int x, int y, int button);
		void mousePressed		(int x, int y, int button);
		void mouseReleased		();
	
		ofVideoGrabber			vid_grabber[2];
	
		// camera image	
		ofxCvColorImage			color_img, color_img_og;				
		// converted grayscale camera image for haar finder
		ofxCvGrayscaleImage 	gray_image, gray_image_sm;	
		
		ofxCvHaarFinder			haar_finder;		// to detect faces
		ofxCvHaarFinder			haar_finder_eyeL;
		ofxCvHaarFinder			haar_finder_eyeR;
	
		glassBall				glass_balls[NUMBER_OF_GLASS_BALLS];
		int						glass_balls_counter;
		int						loaded_all_glass_balls;
	
		//ofQtVideoSaver		movie_out;
	
		ofxCvColorImage			mean_face_image;
		
		bool					show_video, do_mean_shift, show_average, edit_projection,
								find_eyes, find_faces, do_colors, fire_neurons;
	
		ofShader				shader;
		float					fire_width;
	
		/*void audioReceived 	(float * input, int bufferSize, int nChannels); 
	
		float * left;
		float * right;
		int 	bufferCounter;
		int 	drawCounter;*/
};

#endif
